package com.ydd.gateway.util;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Map.Entry;
import java.util.TreeMap;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class Md5Util {

	private static final Log logger = LogFactory.getLog(Md5Util.class);

	private static final String[] STRDIGITS = new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f" };

	public static final String APP_KEY = "BE53C102BA2176C77BCC29F8E4B7EEA9";

	public static String md5(String string) {
		byte[] hash;
		try {
			hash = MessageDigest.getInstance("MD5").digest(string.getBytes("UTF-8"));
		}
		catch (UnsupportedEncodingException e) {
			throw new RuntimeException("UTF-8 is unsupported", e);
		}
		catch (NoSuchAlgorithmException e) {
			throw new RuntimeException("MessageDigest不支持MD5Util", e);
		}
		StringBuilder hex = new StringBuilder(hash.length * 2);
		for (byte b : hash) {
			if ((b & 0xFF) < 0x10) {
				hex.append("0");
			}
			hex.append(Integer.toHexString(b & 0xFF));
		}
		return hex.toString();
	}

	/**
	 * md5签名 按参数名称升序，将参数值进行连接 签名
	 *
	 * @param
	 * @param params
	 * @return
	 */
	public static String sign(TreeMap<String, String> params) {
		StringBuilder paramValues = new StringBuilder();
		for (Entry<String, String> entry : params.entrySet()) {
			paramValues.append(entry.getKey());
			paramValues.append("=");
			paramValues.append(entry.getValue());
		}
		paramValues.append(APP_KEY);
		return md5(paramValues.toString()).toUpperCase();
	}

	/**
	 * 请求参数签名验证
	 *
	 * @param
	 * @param
	 * @return true 验证通过 false 验证失败
	 * @throws Exception
	 */
	public static boolean verifySign(TreeMap<String, String> params, String signStr) {
		return sign(params).equals(signStr);
	}

	private static String byteToString(byte[] bByte) {
		StringBuffer sBuffer = new StringBuffer();

		for (int i = 0; i < bByte.length; ++i) {
			sBuffer.append(byteToArrayString(bByte[i]));
		}

		return sBuffer.toString();
	}

	private static String byteToArrayString(byte bByte) {
		int iRet = bByte;
		if (bByte < 0) {
			iRet = bByte + 256;
		}

		int iD1 = iRet / 16;
		int iD2 = iRet % 16;
		return STRDIGITS[iD1] + STRDIGITS[iD2];
	}

	public static String getMD5Code(String strObj, String charsetname) {
		String resultString = null;

		try {
			new String(strObj);
			MessageDigest md = MessageDigest.getInstance("MD5");
			resultString = byteToString(md.digest(strObj.getBytes(charsetname)));
		}
		catch (Exception var4) {
			var4.printStackTrace();
		}

		return resultString;
	}
}
